package sun.rmi.server;

import java.net.MalformedURLException;
import java.net.URL;
import java.rmi.RMISecurityException;
import java.util.Hashtable;
import sun.applet.AppletClassLoader;

public class RMIClassLoader extends AppletClassLoader {
   private static Hashtable classloaders = new Hashtable();
   private static boolean loaderenabled = true;
   private static RMIClassLoader localloader = null;
   private static boolean initlocalloader = true;

   static synchronized void flushClassLoader(URL var0) {
      classloaders.remove(var0);
   }

   public static synchronized RMIClassLoader getClassLoader(URL var0) {
      if (System.getSecurityManager() == null) {
         throw new RMISecurityException("No security manager, stub class loader disabled");
      } else {
         RMIClassLoader var1 = (RMIClassLoader)classloaders.get(var0);
         if (var1 == null && loaderenabled) {
            try {
               var1 = new RMIClassLoader(var0);
               classloaders.put(var0, var1);
            } catch (Exception var2) {
               loaderenabled = false;
            }
         }

         return var1;
      }
   }

   public static synchronized RMIClassLoader getLocalLoader() throws MalformedURLException {
      if (initlocalloader) {
         initlocalloader = false;
         URL var0 = new URL("file:");

         try {
            String var1 = System.getProperty("java.rmi.server.codebase");
            if (var1 != null && var1.length() != 0) {
               URL var2 = new URL(var0, var1);
               if (System.getSecurityManager() == null) {
                  throw new RMISecurityException("No security manager, stub class loader disabled");
               }

               localloader = new RMIClassLoader(var2);
            }
         } catch (MalformedURLException var3) {
         }
      }

      return localloader;
   }

   public URL getCodeBase() {
      return super.getCodeBase();
   }

   private RMIClassLoader(URL var1) {
      super(var1);
   }

   public Class loadClass(String var1) throws ClassNotFoundException {
      return super.loadClass(var1, true);
   }
}
